//---------------------------------------------------------------------------

#include <vcl.h>
#pragma hdrstop

#include "Unit1.h"
//---------------------------------------------------------------------------
#pragma package(smart_init)
#pragma link "cdiroutl"
#pragma link "InvisPanel"
#pragma resource "*.dfm"
TMainForm *MainForm;

//---------------------------------------------------------------------------
__fastcall TMainForm::TMainForm(TComponent* Owner)
        : TForm(Owner)
{
        srand(time(NULL)*time(NULL));
}
//---------------------------------------------------------------------------
__fastcall TMainForm::~TMainForm()
{
}
//---------------------------------------------------------------------------
void __fastcall TMainForm::FormCreate(TObject *Sender)
{
        MainImage->Picture->Bitmap->PixelFormat = pf32bit;
        MainImage->Picture->Bitmap->Width = MainImage->Width;
        MainImage->Picture->Bitmap->Height = MainImage->Height;
        LineColor = 0xffffff;
        SavePictureDialog->InitialDir = ExtractFilePath(Application->ExeName);
        SaveModelDialog->InitialDir = ExtractFilePath(Application->ExeName);
        OpenModelDialog->InitialDir = ExtractFilePath(Application->ExeName);
        // Use double buffer to avoid flicking effect
        ShowPanel->DoubleBuffered = true;
        return;
}
//---------------------------------------------------------------------------
//
//  Graphics
//
//---------------------------------------------------------------------------
void __fastcall TMainForm::Draw()
{
  int method = 2;
  unsigned int *ptr;
  int i,j;
  // Measure drawing time
  LARGE_INTEGER timerFrequency;
  LARGE_INTEGER startTime;
  LARGE_INTEGER currentTime;
  QueryPerformanceFrequency(&timerFrequency);
  QueryPerformanceCounter(&startTime);

/////////////////////////////////////////////////////////////////////////////
// Example of direct drawing on image                                      //
/////////////////////////////////////////////////////////////////////////////
  if(method == 1){
// Draw Method 1
        // Step1. Create a TBitmap object for drawing
        Graphics::TBitmap *pBitmap = new Graphics::TBitmap();
        pBitmap->PixelFormat = pf32bit;
        pBitmap->Height = MainImage->Height;
        pBitmap->Width = MainImage->Width;
        // Step2. Draw on pBitmap
        for (j = 0; j < MainImage->Height; j++){
                // Get scanline
                ptr = (unsigned int *)pBitmap->ScanLine[j];
                for (i = 0; i < MainImage->Width; i++){
                  // Draw each pixel
                  ptr[i] = j*MainImage->Width+i*256+65536*128;
                }
        }
        // Step3. Draw pBitmap on MainImage
        MainImage->Canvas->Draw(0,0,pBitmap);
        pBitmap = NULL;
  }
  else{
// Draw Method 2
        // Step1. Clear Screen
        // Color 0x00bbggrr
        ClearScreen(65536);
        // Step2. Draw on MainImage
        for (j = 0; j < MainImage->Height; j++){
          // Get scanline
          ptr = (unsigned int *)MainImage->Picture->Bitmap->ScanLine[j];
          for(i = 0; i < MainImage->Width; i++){
          // Draw each pixel
            ptr[i] = j*MainImage->Width+i;
          }
        }
        // Step3. Invalidate MainImage
        MainImage->Invalidate();
  }
/////////////////////////////////////////////////////////////////////////////
// Example of drawing triangle on image                                    //
/////////////////////////////////////////////////////////////////////////////
  DrawTri(1,1,300,1,150,150);

  ptr = NULL;
  return;
  QueryPerformanceCounter(&currentTime);
}
//---------------------------------------------------------------------------
//
//      Draw function
//
//---------------------------------------------------------------------------
void __fastcall TMainForm::ClearScreen(TColor Color){
  TColor temp = MainImage->Canvas->Pen->Color;
  MainImage->Canvas->Brush->Color = Color;
  MainImage->Canvas->FillRect(Rect(0,0,MainImage->Width-1,MainImage->Height-1));
  MainImage->Canvas->Pen->Color = temp;
}
//---------------------------------------------------------------------------
void __fastcall TMainForm::DrawTri(int X1,int Y1,int X2,int Y2,int X3,int Y3)
{
  MainImage->Canvas->MoveTo(X1,Y1);
  MainImage->Canvas->LineTo(X2,Y2);
  MainImage->Canvas->LineTo(X3,Y3);
  MainImage->Canvas->LineTo(X1,Y1);
}
//---------------------------------------------------------------------------
//
//  Routines
//
//---------------------------------------------------------------------------
void __fastcall TMainForm::ShowPanelResize(TObject *Sender)
{
  MainImage->Width = ShowPanel->Width-2;
  MainImage->Height = ShowPanel->Height-2;
  MainImage->Picture->Bitmap->Width = MainImage->Width;
  MainImage->Picture->Bitmap->Height = MainImage->Height;
  Draw();
}
//---------------------------------------------------------------------------

void __fastcall TMainForm::FormResize(TObject *Sender)
{
  MainImage->Width = ShowPanel->Width-2;
  MainImage->Height = ShowPanel->Height-2;
  MainImage->Picture->Bitmap->Width = MainImage->Width;
  MainImage->Picture->Bitmap->Height = MainImage->Height;
  Draw();
}
//---------------------------------------------------------------------------

//
//  Member Function of class TMainForm
//  Menu operation
//---------------------------------------------------------------------------
void __fastcall TMainForm::SaveModelMenuItemClick(TObject *Sender)
{
        if(Model.mode == 0){
                MessageBox(0,"|Jɮ","~",MB_OK);
                return;
        }
        char ext[MAXEXT];
        if(!SaveModelDialog->Execute())
                return;
        if (FileExists(SaveModelDialog->FileName)){
                if(MessageBox(0,"ɮפwgsbAnмgH","`NI",MB_YESNO) == IDNO)
                        return;
        }
        fnsplit(SaveModelDialog->FileName.c_str(), 0, 0, 0, ext);
        if(!strcmpi(ext,".tri")){
                Model.SaveTri(SaveModelDialog->FileName.c_str());
        }
        else{
                MessageBox(0,"ɮ׫A","",MB_OK);
        }
}
//---------------------------------------------------------------------------
void __fastcall TMainForm::SaveModelDialogTypeChange(TObject *Sender)
{
        switch(SaveModelDialog->FilterIndex){
                case 1:
                        SaveModelDialog->DefaultExt = "tri";
                break;
        }
}
//---------------------------------------------------------------------------
void __fastcall TMainForm::OpenModelMenuItemClick(TObject *Sender)
{
        char ext[MAXEXT];
        if(!OpenModelDialog->Execute())
                return;
        if(FileExists(OpenModelDialog->FileName)){
          // Get the file's extension name
          fnsplit(OpenModelDialog->FileName.c_str(), 0, 0, 0, ext);
          if(!strcmpi(ext,".tri")){
            Model.LoadTri(OpenModelDialog->FileName.c_str());
          }
          Model.Stat();
        }
        else{
                MessageBox(0,"䤣ɮ","~",MB_OK);
                return;
        }
}
//---------------------------------------------------------------------------
void __fastcall TMainForm::SaveImageMenuItemClick(TObject *Sender)
{
        if(!SavePictureDialog->Execute())
                return;
        char ext[MAXEXT];
        if (FileExists(SavePictureDialog->FileName)){
                if(MessageBox(0,"ɮפwgsbAnмgH","`NI",MB_YESNO) != IDYES)
                        return;
        }
        MainImage->Picture->SaveToFile(SavePictureDialog->FileName);
        return;
}
//---------------------------------------------------------------------------

void __fastcall TMainForm::CloseFileMenuItemClick(TObject *Sender)
{
        //Release opened file
        Model.Unload();
        if(Model.mode ==0){
                SaveModelMenuItem->Enabled = false;
                SaveImageMenuItem->Enabled = false;
                CloseFileMenuItem->Enabled = false;
        }
        ClearScreen(0x00);
}
//---------------------------------------------------------------------------
void __fastcall TMainForm::ExitMenuItemClick(TObject *Sender)
{
        Application->Terminate();
}
//---------------------------------------------------------------------------
void __fastcall TMainForm::ChangeColorMenuItemClick(TObject *Sender)
{
        if (ChangeColorDialog->Execute()){
                /*
                int i = (ChangeColorDialog->Color & 0x000000ff) << 16;
                int j = ChangeColorDialog->Color & 0x0000ff00;
                int k = (ChangeColorDialog->Color & 0x00ff0000) >> 16;
                LineColor = i+j+k;
                */
                MainImage->Canvas->Pen->Color = ChangeColorDialog->Color;
                Draw();
        }
}

//---------------------------------------------------------------------------
//
//      Move mouse on the image
//
//---------------------------------------------------------------------------
void __fastcall TMainForm::MainImageMouseUp(TObject *Sender,
      TMouseButton Button, TShiftState Shift, int X, int Y)
{
//enum TMouseButton { mbLeft, mbRight, mbMiddle };
  Draw();
  return;
}
//---------------------------------------------------------------------------
void __fastcall TMainForm::MainImageMouseDown(TObject *Sender,
      TMouseButton Button, TShiftState Shift, int X, int Y)
{
//enum TMouseButton { mbLeft, mbRight, mbMiddle };
  Draw();
  return;
}
//---------------------------------------------------------------------------
void __fastcall TMainForm::MainImageMouseMove(TObject *Sender,
      TShiftState Shift, int X, int Y)
{
//enum TMouseButton { mbLeft, mbRight, mbMiddle };
  Draw();
  return;
}
//---------------------------------------------------------------------------
//
//  Member Function of class MyModel
//
//---------------------------------------------------------------------------
__fastcall MyModel::MyModel():mode(0),ModelSize(0),NumVertex(0),NumNormal(0),NumFace(0)
{
        Min.x = Min.y = Min.z = Max.x = Max.y = Max.z = 0;
//        Centroid.x = Centroid.y = Centroid.z = 0;
        return;
}
//---------------------------------------------------------------------------
__fastcall MyModel::~MyModel()
{
        Unload();
        return;
}
//---------------------------------------------------------------------------
//
//  Deal with TRI File
//
//---------------------------------------------------------------------------
bool __fastcall MyModel::LoadTri(const char* filename)
{
	FILE *infile = NULL;
	char FirstToken[10] = "";
        char StringBuffer[81] = "";
        bool fail=false;
        int TempFace;
	if((infile = fopen(filename, "r")) == NULL)
		return false;
//Preprocessing Stage
        //Search for "Triangle"
        TempFace = 0;
        while(fgets(StringBuffer,80,infile) != NULL){
                if(strcmpi(StringBuffer,"Triangle\n") == 0)
                        TempFace++;
        }
        //Check if the file is a TRI file
        if(TempFace == 0){
                MessageBox(NULL,"ɮפL","",MB_OK);
                return false;
        }
        //Clear old data
        Unload();
        //Get file type and size
        ModelSize = filelength(fileno(infile));
        mode = 2;
        //There are 3 Vertex and Normal in 1 Face
        NumFace   = TempFace;
        NumVertex = TempFace * 3;
        NumNormal = TempFace * 3;
        NumPart = 1;
        //Rewind
        fseek(infile, 0L, SEEK_SET);
//Allocate memory
// malloc version
/*
        if((FaceList = (MyFace*)malloc(sizeof(MyFace) * NumFace)) == NULL)
                MessageBox(NULL,"Fail to allocate memory for Face data","",MB_OK);
        if((VertexList = (MyVector*)malloc(sizeof(MyVector) * NumVertex)) == NULL)
                MessageBox(NULL,"Fail to allocate memory for Vertex data","",MB_OK);
        if((NormalList = (MyVector*)malloc(sizeof(MyVector) * NumNormal)) == NULL)
                MessageBox(NULL,"Fail to allocate memory for Normal data","",MB_OK);
*/
// new version
        if((FaceList = new MyFace[NumFace+100]) == NULL)
                MessageBox(NULL,"Fail to allocate memory for Face data","",MB_OK);
        if((VertexList = new MyVector[NumVertex+100]) == NULL)
                MessageBox(NULL,"Fail to allocate memory for Vertex data","",MB_OK);
        if((NormalList = new MyVector[NumNormal+100]) == NULL)
                MessageBox(NULL,"Fail to allocate memory for Normal data","",MB_OK);

//Read Stage
        int i=0;
	while(fscanf(infile,"%s",FirstToken) != EOF){
		if(strcmpi(FirstToken,"Triangle") == 0){
//Read Face Data
			if(fscanf(infile,"%u %u %u %u %u %u",&FaceList[i].ForeColor[0],&FaceList[i].ForeColor[1],&FaceList[i].ForeColor[2],&FaceList[i].BackColor[0],&FaceList[i].BackColor[1],&FaceList[i].BackColor[2]) == EOF)
                                fail = true;
			if(fscanf(infile,"%f%f%f%f%f%f",&VertexList[3*i].x,&VertexList[3*i].y,&VertexList[3*i].z,&NormalList[3*i].x,&NormalList[3*i].y,&NormalList[3*i].z) == EOF)
                                fail = true;
			if(fscanf(infile,"%f%f%f%f%f%f",&VertexList[3*i+1].x,&VertexList[3*i+1].y,&VertexList[3*i+1].z,&NormalList[3*i+1].x,&NormalList[3*i+1].y,&NormalList[3*i+1].z) == EOF)
                                fail = true;
			if(fscanf(infile,"%f%f%f%f%f%f",&VertexList[3*i+2].x,&VertexList[3*i+2].y,&VertexList[3*i+2].z,&NormalList[3*i+2].x,&NormalList[3*i+2].y,&NormalList[3*i+2].z) == EOF)
                                fail = true;
                        FaceList[i].VIndex[0] = 3*i;
                        FaceList[i].VIndex[1] = 3*i+1;
                        FaceList[i].VIndex[2] = 3*i+2;
                        FaceList[i].NIndex[0] = 3*i;
                        FaceList[i].NIndex[1] = 3*i+1;
                        FaceList[i].NIndex[2] = 3*i+2;
                        i++;
		}
    else
      fail = true;
    if(fail){
      MessageBox(NULL,"~ɮ׮榡ɮפwglI","",MB_OK);
      Unload();
      return false;
    }
	}
	fclose(infile);
        return true;
}
//---------------------------------------------------------------------------
bool __fastcall MyModel::SaveTri(const char* filename)
{
        FILE *outfile;
        if((outfile=fopen(filename,"w")) == NULL){
                MessageBox(NULL,"Lkxsɮ","",MB_OK);
        }
        //gJɮ
        for(int i=0;i<NumFace;i++){
                fprintf(outfile,"Triangle\n");
                fprintf(outfile,"%u %u %u %u %u %u\n",FaceList[i].ForeColor[0],FaceList[i].ForeColor[1],FaceList[i].ForeColor[2],FaceList[i].BackColor[0],FaceList[i].BackColor[1],FaceList[i].BackColor[2]);
                fprintf(outfile,"%f   %f   %f   %f   %f   %f\n",VertexList[FaceList[i].VIndex[0]].x,VertexList[FaceList[i].VIndex[0]].y,VertexList[FaceList[i].VIndex[0]].z,NormalList[FaceList[i].NIndex[0]].x,NormalList[FaceList[i].NIndex[0]].y,NormalList[FaceList[i].NIndex[0]].z);
                fprintf(outfile,"%f   %f   %f   %f   %f   %f\n",VertexList[FaceList[i].VIndex[1]].x,VertexList[FaceList[i].VIndex[1]].y,VertexList[FaceList[i].VIndex[1]].z,NormalList[FaceList[i].NIndex[1]].x,NormalList[FaceList[i].NIndex[1]].y,NormalList[FaceList[i].NIndex[1]].z);
                fprintf(outfile,"%f   %f   %f   %f   %f   %f\n",VertexList[FaceList[i].VIndex[2]].x,VertexList[FaceList[i].VIndex[2]].y,VertexList[FaceList[i].VIndex[2]].z,NormalList[FaceList[i].NIndex[2]].x,NormalList[FaceList[i].NIndex[2]].y,NormalList[FaceList[i].NIndex[2]].z);
        }
        fclose(outfile);
        return true;
}
//---------------------------------------------------------------------------
void __fastcall MyModel::Stat()
{
        int i;
        Max.x = Max.y = Max.z = Min.x = Min.y = Min.z = 0;
        for(i=0;i<NumVertex;i++){
                if(VertexList[i].x > Max.x)
                        Max.x = VertexList[i].x;
                if(VertexList[i].x < Min.x)
                        Min.x = VertexList[i].x;
                if(VertexList[i].y > Max.y)
                        Max.y = VertexList[i].y;
                if(VertexList[i].y < Min.y)
                        Min.y = VertexList[i].y;
                if(VertexList[i].z > Max.z)
                        Max.z = VertexList[i].z;
                if(VertexList[i].z < Min.z)
                        Min.z = VertexList[i].z;
        }
        Center.x = (Max.x+Min.x)/2;
        Center.y = (Max.y+Min.y)/2;
        Center.z = (Max.z+Min.z)/2;
}
//---------------------------------------------------------------------------
bool __fastcall MyModel::Unload()
{
        mode = 0;
        NumVertex = 0;
        NumNormal = 0;
        NumFace = 0;
        NumPart = 0;
        ModelSize = 0;
        Min.x = Min.y = Min.z = Max.x = Max.y = Max.z = 0;
//        Centroid.x = Centroid.y = Centroid.z = 0;
        // free version
        /*
                if(FaceList != NULL){
                        free((VERTEX*)FaceList);
                        FaceList = NULL;
                }
                if(VertexList != NULL){
                        free((VERTEX*)VertexList);
                        VertexList = NULL;
                }
                if(NormalList != NULL){
                        free((VERTEX*)NormalList);
                        NormalList = NULL;
                }
        */
        // delete version
                if(FaceList != NULL){
                        delete[] FaceList;
                        FaceList = NULL;
                }
                if(VertexList != NULL){
                        delete[] VertexList;
                        VertexList = NULL;
                }
                if(NormalList != NULL){
                        delete[] NormalList;
                        NormalList = NULL;
                }

        return true;
}
