//---------------------------------------------------------------------------

#ifndef Unit1H
#define Unit1H
//---------------------------------------------------------------------------
#include <Classes.hpp>
#include <Controls.hpp>
#include <StdCtrls.hpp>
#include <Forms.hpp>
#include <Menus.hpp>
#include "cdiroutl.h"
#include <Grids.hpp>
#include <Outline.hpp>
#include <FileCtrl.hpp>
#include <ExtCtrls.hpp>
#include <CustomizeDlg.hpp>
#include <Buttons.hpp>
#include <jpeg.hpp>
#include <Dialogs.hpp>
#include <ExtDlgs.hpp>
//---------------------------------------------------------------------------
#include <stdio.h>
#include <stdlib.h>
#include <alloc.h>
#include <dir.h>
#include <io.h>
#include <string.h>
#include <math.h>
#include <exception>
#include <iostream>
#include <vector>
using namespace std;
//---------------------------------------------------------------------------
typedef struct VERTEX
{
        float x,y,z;
} MyVector;
typedef struct FCOLOR
{
        unsigned char Name[30];
        float r,g,b;
} MyColor;
typedef struct TRIANGLE
{
        int VIndex[3];
        int NIndex[3];
        int CIndex[3];
        unsigned char ForeColor[3],BackColor[3];
} MyFace;
//---------------------------------------------------------------------------
class MyModel{
public:
        int mode;                               //Model file type
                                                //0 : No data
                                                //1 : OBJ
                                                //2 : TRI
                                                //3 : PLY
        char FileName[255];                     //filename of the model
        long ModelSize;                         //Size of the model file(bytes)
        int NumVertex,NumNormal,NumFace,NumPart;//Statis of Model
        MyVector Min,Max;                       //Bounding box
        MyVector Center;                        //Center of the model
                                                // use half of the bounding box
                                                // as the center
        MyVector *VertexList;                   //Array of vertex
        MyVector *NormalList;                   //Array of normals
        MyFace   *FaceList;                     //Array of faces
        bool __fastcall LoadTri(const char*);   //Load Tri File
        bool __fastcall SaveTri(const char*);   //Save Tri File
        void __fastcall Stat();                 //Count function
        bool __fastcall Unload();               //Unload model file

        __fastcall MyModel();                              //Constructor
        __fastcall ~MyModel();                             //Destructor
};
//---------------------------------------------------------------------------
class TMainForm : public TForm
{
__published:	// IDE-managed Components
        TPanel *ShowPanel;
        TMainMenu *MainMenu;
        TMenuItem *Menu_File;
        TMenuItem *OpenModelMenuItem;
        TMenuItem *SaveModelMenuItem;
        TMenuItem *SaveImageMenuItem;
        TMenuItem *ExitMenuItem;
        TMenuItem *Menu_View;
        TMenuItem *ViewPoint;
        TMenuItem *ViewWire;
        TMenuItem *ViewShadeMenuItem;
        TMenuItem *ViewFlat;
        TMenuItem *ChangeColorMenuItem;
        TImage *MainImage;
        TMenuItem *CloseFileMenuItem;
        TOpenDialog *OpenModelDialog;
        TSaveDialog *SaveModelDialog;
        TSavePictureDialog *SavePictureDialog;
        TMenuItem *ViewGouraud;
        TMenuItem *ViewPhong;
        TColorDialog *ChangeColorDialog;
        TMenuItem *Projection1;
        TMenuItem *ProjOrtho;
        TMenuItem *ProjPersp;
        TMenuItem *BackFaceCulling;
        TTimer *RefreshTimer;
        void __fastcall FormCreate(TObject *Sender);
        void __fastcall ShowPanelResize(TObject *Sender);
        void __fastcall FormResize(TObject *Sender);
        void __fastcall SaveModelMenuItemClick(TObject *Sender);
        void __fastcall OpenModelMenuItemClick(TObject *Sender);
        void __fastcall SaveImageMenuItemClick(TObject *Sender);
        void __fastcall CloseFileMenuItemClick(TObject *Sender);
        void __fastcall ExitMenuItemClick(TObject *Sender);
        void __fastcall SaveModelDialogTypeChange(TObject *Sender);
        void __fastcall MainImageMouseDown(TObject *Sender,
          TMouseButton Button, TShiftState Shift, int X, int Y);
        void __fastcall MainImageMouseUp(TObject *Sender,
          TMouseButton Button, TShiftState Shift, int X, int Y);
        void __fastcall MainImageMouseMove(TObject *Sender,
          TShiftState Shift, int X, int Y);
        void __fastcall ChangeColorMenuItemClick(TObject *Sender);
private:	// User declarations
public:		// User declarations
        __fastcall TMainForm(TComponent* Owner);
        __fastcall ~TMainForm();

        void __fastcall ClearScreen(TColor Color);
        void __fastcall Draw();
        void __fastcall DrawTri(int X1,int Y1,int X2,int Y2,int X3,int Y3);

        MyModel Model;
        DWORD LineColor;
};
//---------------------------------------------------------------------------
extern PACKAGE TMainForm *MainForm;
//---------------------------------------------------------------------------
#endif
